package practica4;

// Clase para realizar todo tipo de clculos
public class Calcular {

	// Constructor
	public Calcular() {
	}

	// Mtodo para calcular el grado de emparejamiento
	public int gradoEmparejamiento(int x, int a, int b, int c,
			int d) {

		// Si el valor est en el primer tramo
		if (a <= x && x < b)
			return (x - a) / (b - a);
		// Si est en el segundo tramo
		else if (b <= x && x < c)
			return 1;
		// Si est en el tercer tramo
		else if (c <= x && x < d)
			return (x - d) / (c - d);
		// Si no est en ninguno de los anteriores
		else
			return 0;
	}

	// Mtodo para calcular la conjuncin (T-norma del mnimo)
	public int conjuncionMinimo(int emparejamiento1,
			int emparejamiento2) {

		return Math.min(emparejamiento1, emparejamiento2);

	}

	// Mtodo para calcular la inferencia (T-norma del mnimo)
	public int[] inferenciaMinimo(int h, int a, int b, int c,
			int d) {

		// Variable para almacenar el resultado
		/*
		 * resultado[0] --> valor de x4 resultado[1] --> valor de x5
		 */
		int[] resultado = new int[2];

		// Valor de x4
		resultado[0] = a + (b - a) * h;

		// Valor de x5
		resultado[1] = c - (c - b) * h;

		return resultado;

	}

	// Mtodo para calcular el punto de mximo valor ponderado por el grado
	// de emparejamiento
	public int desborrosificacion(int[] h, int[] a, int[] b) {

		// Variable para almacenar el resultado del numerador
		/*
		 * La inicializamos a cero
		 */
		int numerador = 0;

		// Variable para almacenar el resultado del denominador
		/*
		 * La inicializamos a cero
		 */
		int denominador = 0;

		// Realizamos el clculo de los sumatorios
		for (int i = 0; i < h.length; i++) {

			// Si tiene algn valor
			if (h[i] != 0) {
				// Calculamos el numerador
				numerador += h[i] * ((a[i] + b[i]) / 2);

				// Calculamos el denominador
				denominador += h[i];
			}

		}

		// Si el denominador es cero mostramos un mensaje por pantalla
		if (denominador == 0){
			System.out.println("Error de divisin por cero en mtodo desborrosificacin");
			return -1;
		}
		// Si no es cero
		else{
			// Devolvemos el resultado
			return (numerador / denominador);
		}

	}

}