package practica4;

// Clase que almacena las tablas de reglas y las coordenadas de los conjuntos
// difusos
public class Tablas {

        // Tabla para almacenar las reglas
        private int[][] reglas;

        // Tabla para almacenar las coordenadas de los conjuntos difusos
        private int[][] coordenadas;

        // Constructor
        /*
         * conjuntosDifusos -> nmeros de conjuntos difusos a cargar coordenadas ->
         * nmero de coordenadas por cada conjunto difuso reglas -> nmero de reglas
         * 3 -> 2 antecedentes y 1 consecuente
         */
        public Tablas(int conjuntosDifusos, int coordenadas, int reglas) {
             //   this.reglas = new int[reglas][3];
             //   this.coordenadas = new int[conjuntosDifusos][coordenadas];
        }

        // Mtodo que aade las coordenadas al conjunto difuso
        public void setCoordenadas(int conjuntoDifuso, int coordenada, int valor) {
                this.coordenadas[conjuntoDifuso][coordenada] = valor;
        }

        // Mtodo que devuelve las coordenadas del conjunto difuso
        public double getCoordenadas(int conjuntoDifuso, int coordenada) {
                return (this.coordenadas[conjuntoDifuso][coordenada]);
        }

        // Mtodo para aadir los 2 antecedentes y el consecuente
        public void setReglas(int numeroRegla, int antecedente1, int antecedente2,
                        int consecuente) {
                this.reglas[numeroRegla][0] = antecedente1;
                this.reglas[numeroRegla][1] = antecedente2;
                this.reglas[numeroRegla][2] = consecuente;
        }

        // Mtodo que devuelve el antecedente1 de una regla
        public int[] getAntecedente1(int regla) {
                return (this.coordenadas[this.reglas[regla][0]]);
        }

        // Mtodo que devuelve el antecedente1 de una regla
        public int[] getAntecedente2(int regla) {
                return this.coordenadas[this.reglas[regla][1]];
        }

        // Mtodo que devuelve el cosecuente de una regla
        public int[] getConsecuente(int regla) {
                return this.coordenadas[this.reglas[regla][2]];
        }

        // Mtodo que devuelve la tabla de reglas
        public int[][] getReglas(){
                return this.reglas;
        }

        // Mtodo que devuelve la tabla de coordenadas
        public int[][] getCoordenadas(){
                return this.coordenadas;
        }

}